#include "Weather.h"

Weather::Weather( )
  : mHeight(0), mWidth(0) {
  /* 2 slots for each grid location */
  mData.resize( mHeight * mWidth * 2 );
}

Weather::Weather( const int& height, const int& width )
  : mHeight(height), mWidth(width)  {
  /* 2 slots for each grid location */
  mData.resize( mHeight * mWidth * 2 );
}

int Weather::getHeight( ) const {
  return mHeight;
}

int Weather::getWidth( ) const {
  return mWidth;
}

double Weather::getValue( const int& row, const int& column, const int& which_value ) const {
  /* which_value == 0 for temperature
   * which_value == 1 for wind speed */
  double value = -1000000.0;
  /* Check to be sure that the grid location specified is in the grid, and the value exists. */
  if( row >= 0 && row < mHeight && column >= 0 && column < mWidth && which_value >= 0 && which_value < 2 ) {
    int index = ( row * mWidth * 2 ) + ( column * 2 ) + which_value;
    value = mData[ index ];
  }
  return value;
}

void Weather::setValue( const int& row, const int& column, const int& which_value, const double& value ) {
  /* which_value == 0 for temperature
   * which_value == 1 for wind speed */
  /* Check to be sure that the grid location specified is in the grid, and the value exists. */
  if( row >= 0 && row < mHeight && column >= 0 && column < mWidth && which_value >= 0 && which_value < 2 ) {
    int index = ( row * mWidth * 2 ) + ( column * 2 ) + which_value;
    mData[ index ] = value;
  }
}
