#ifndef _WEATHER_H_
#define _WEATHER_H_

#include <vector>

class Weather {
public:
  Weather( );
  Weather( const int& height, const int& width );

  int getHeight( ) const;
  int getWidth( ) const;

  /* which_value == 0 means temperature
   * which_value == 1 means wind speed
   */
  double getValue( const int& row, const int& column, const int& which_value ) const;
  void setValue( const int& row, const int& column, const int& which_value, const double& value );

private:
  int mHeight;
  int mWidth;
  /*
   * The data represents temperature and wind speed data for a grid of map locations.
   * mHeight and mWidth are the dimensions of the grid.
   * There are 2 values in each grid location.
   * Read the implementations of getValue() and setValue() to see how the values
   * are stored in and retrieved from mData.
   * See the constructors to see how the grid (mData) is sized to have the right number of slots for the grid.
   */
  std::vector< double > mData;
};

#endif /* _WEATHER_H_ */
/* Local Variables: */
/* mode:c++         */
/* End:             */
