#include "student.h"
#include <iostream>

// constructor chains to the default Person() constructor
Student::Student( )
  : mGPA( 4.0 ) {
}

// constructor chains to the Person( string, int ) constructor
Student::Student( const double& gpa ) 
  : Person( "Samuel Brooks", 18 ), mGPA( gpa ) {
}

// constructor chains to the Person( string, int ) constructor
Student::Student( const std::string& name, const int& age, const double& gpa )
  : Person( name, age ), mGPA( gpa ) {
  // Person( name, age ); <<< BAD, DOES NOT WORK.
}

Student::~Student( ) {
  mGPA = 0.0;
  std::cout << "~Student" << std::endl;
}

void Student::setName( const std::string& name ) {
  //mName = name; // private, can't access
  // call Person::setName()
  Person::setName( "Student: " + name );
}

double Student::getGPA( ) const {
  return mGPA;
}

void Student::setGPA( const double& gpa ) {
  mGPA = gpa;
}
