C++ Pointers
============

The use of `*` can be confusing in C++, until
you understand the concept of an address and
follow a couple of context rules for understanding
the meaning of `*`.

Rule 1
------

When `*` is used in an arithmetic expression
it means multiplication.

Rule 2
------

When `*` is used in a variable declaration, the
variable is a pointer. A pointer is a variable
that stores an address or location.  The type of
value that the pointer points to is important:
`char *` and `int *` are different.

Rule 3
------

When `*` is used in the parameter list of a function,
it is the same as a variable declaration.  It means
the parameter is a pointer variable, and holds the
address of a location in memory.

Rule 4
------

When `*` is used in the return type of a function,
it means the return value of the function is the
address of a location in memory.  It is important
for function *not* to return addresses that point
to stack memory.

Rule 5
------

When `*` is used in an expression (not a declaration) 
directly in front of a pointer variable, it dereferences 
the pointer.  This means that the expression will use the
value of the data that is stored in memory at the location
identified by the value of the pointer.


