#include "prime_functions.h"
#include <iostream>
#include <sstream>
#include <thread>
#include <functional>

int main(int argc, char *argv[]) {
  int n = 12;
  if(argc >= 2) {
    std::stringstream ss(argv[1]);
    ss >> n;
  }

  int c1, c2;
  int split = 3*n/4;

  std::thread t1(count_primes_in_range_worker, 2, split, std::ref(c1));
  std::thread t2(count_primes_in_range_worker, split+1, n, std::ref(c2));

  t1.join();
  t2.join();

  int count = c1 + c2;

  std::cout << "There are " << count << " primes in the range [2, " << n << "]." << std::endl;
  return 0;
}

