#include "prime_functions.h"
#include "PrimeCounter.h"
#include <thread>

PrimeCounter::PrimeCounter() {
}

int PrimeCounter::countPrimes(int n) {
  std::vector<int> counts;
  int n_threads = (int)std::thread::hardware_concurrency();
  mTasks.resize(n-1);
  int i;
  for(i = 2; i <= n; i++) {
    mTasks[i-2] = i;
  }
  counts.resize(n_threads);
  std::vector<std::thread> threads;
  for(i = 0; i < n_threads; i++) {
    threads.push_back(std::thread(&PrimeCounter::countPrimesWorker, this, std::ref(counts[i])));
  }

  int count = 0;
  for(i = 0; i < n_threads; i++) {
    threads[i].join();
    count += counts[i];
  }
  return count;
}

void PrimeCounter::countPrimesWorker(int& count) {
  int x;
  count = 0;
  while(mTasks.size() > 0) {

    mLock.lock();
    if(mTasks.size()) {
      x = mTasks.back();
      mTasks.pop_back();
    } else {
      x = -1;
    }
    mLock.unlock();
    if(x > 0) {
      if(is_prime(x)) {
        count++;
      }
    }
  }

}
